<?php
/**
 * Initialize the custom theme options.
 */
add_action( 'admin_init', 'custom_theme_options' );

/**
 * Build the custom settings & update OptionTree.
 */
function custom_theme_options() {
  
  /* OptionTree is not loaded yet */
  if ( ! function_exists( 'ot_settings_id' ) )
    return false;
    
  /**
   * Get a copy of the saved settings array. 
   */
  $saved_settings = get_option( ot_settings_id(), array() );
  
  /**
   * Custom settings array that will eventually be 
   * passes to the OptionTree Settings API Class.
   */
  $custom_settings = array( 
    'contextual_help' => array( 
      'sidebar'       => ''
    ),
    'sections'        => array( 
      array(
        'id'          => 'general',
        'title'       => 'Genel Ayarlar'
      ),
      array(
        'id'          => 'index',
        'title'       => 'Anasayfa'
      ),
      array(
        'id'          => 'footer',
        'title'       => 'Footer'
      ),
      array(
        'id'          => 'social',
        'title'       => 'Sosyal Medya'
      ),
      array(
        'id'          => 'reklam',
        'title'       => 'Site Reklam Alanları'
      )
    ),
    'settings'        => array( 
      array(
        'id'          => 'logo',
        'label'       => 'Logo',
        'std'         => '',
        'type'        => 'upload',
        'section'     => 'general',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'cr',
        'label'       => 'Footer Yazınız',
        'desc'        => 'Footer için görünmesi istediğiniz yazıyı giriniz',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'general',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'header_reklam_1',
        'label'       => 'Header Reklam',
        'desc'        => 'Header Reklam Kodunuz (468x60) ',
        'std'         => '',
        'type'        => 'textarea_simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'turler',
        'label'       => 'Türler Sayfasını Seçiniz',
        'desc'        => 'Sol Kolonda Bulunan Tür Sayfasını Seçiniz.',
        'std'         => '',
        'type'        => 'page_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
       array(
        'id'          => 'sonra_izle',
        'label'       => 'Sonra İzleyeceklerim Sayfasını Seçiniz',
        'desc'        => 'Sol Kolonda Bulunan Sonra İzleyeceklerim Sayfasını Seçiniz.',
        'std'         => '',
        'type'        => 'page_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'bildir',
        'label'       => 'Bildir Sayfasını Seçiniz',
        'desc'        => 'Sol Kolonda Bulunan Bildir Sayfasını Seçiniz.',
        'std'         => '',
        'type'        => 'page_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),

 array(
        'id'          => 'tab_1_kat',
        'label'       => 'Tab Kategorinizi Seçiniz - 1',
        'desc'        => '1.Kolonda Listelenmesini İstediğiniz Tab Kategorisini Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),

 array(
        'id'          => 'tab_2_kat',
        'label'       => 'Tab Kategorinizi Seçiniz - 2',
        'desc'        => '1.Kolonda Listelenmesini İstediğiniz Tab Kategorisini Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),

 array(
        'id'          => 'tab_3_kat',
        'label'       => 'Tab Kategorinizi Seçiniz - 3',
        'desc'        => '1.Kolonda Listelenmesini İstediğiniz Tab Kategorisini Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),

 array(
        'id'          => 'tab_4_kat',
        'label'       => 'Tab Kategorinizi Seçiniz - 4',
        'desc'        => '1.Kolonda Listelenmesini İstediğiniz Tab Kategorisini Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'ozel_kat_1',
        'label'       => 'Özel Kategorinizi Seçiniz - 1',
        'desc'        => '1.Kolonda Listelenmesini İstediğiniz Özel Kategoriyi Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'ozel_kat_2',
        'label'       => 'Özel Kategorinizi Seçiniz - 2',
        'desc'        => '2.Kolonda Listelenmesini İstediğiniz Özel Kategoriyi Seçiniz',
        'std'         => '',
        'type'        => 'category_select',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'alfabetik_dizi_listesi',
        'label'       => 'Alfabetik Dizi Listesi Aç-Kapa',
        'desc'        => '',
        'std'         => 'off',
        'type'        => 'on-off',
        'section'     => 'index',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'facebook',
        'label'       => 'Facebook',
        'desc'        => 'Facebook Kullanıcı Linki',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'social',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'twitter',
        'label'       => 'Twitter',
        'desc'        => 'Twitter Kullanıcı Linki',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'social',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'gplus',
        'label'       => 'Google Plus',
        'desc'        => 'Google+ ID',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'social',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'logo_yaziniz',
        'label'       => 'Logo Yazınız (Örneğin : Lab)',
        'desc'        => '',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'footer',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'footer_yazi',
        'label'       => 'Footer İçerik Yazınız',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea',
        'section'     => 'footer',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'pageskin',
        'label'       => 'PageSkin Aç-Kapa',
        'desc'        => '',
        'std'         => 'off',
        'type'        => 'on-off',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'pageskin_arka',
        'label'       => 'PageSkin Arkaplan Resminiz.',
        'desc'        => '',
        'std'         => '',
        'type'        => 'upload',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => 'pageskin:is(on),reklam:not()',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'pageskin_sag',
        'label'       => 'Page Skin Sağ Tıklama Linkiniz',
        'desc'        => '',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => 'pageskin:is(on),reklam:not()',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'pageskin_sol',
        'label'       => 'Page Skin Sol Tıklama Linkiniz',
        'desc'        => '',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => 'pageskin:is(on),reklam:not()',
        'operator'    => 'and'
      ),
 array(
        'id'          => 'video_oncesi',
        'label'       => 'Video Öncesi Reklam Aç-Kapa',
        'desc'        => '',
        'std'         => 'off',
        'type'        => 'on-off',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'video_oncesi_reklam_kodunuz',
        'label'       => 'Video Öncesi Reklam Kodunuz.',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea-simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => 'video_oncesi:is(on),reklam:not()',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'video_oncesi_reklam_suresi',
        'label'       => 'Video Öncesi Reklam Süresi',
        'desc'        => '',
        'std'         => '',
        'type'        => 'text',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => 'video_oncesi:is(on),reklam:not()',
        'operator'    => 'and'
      ),

      array(
        'id'          => 'anasayfa_tab_ustu',
        'label'       => 'Anasayfa Tab Menü Üstü Reklam Kodlarınız (728x90)',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea-simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'single_video_ustu',
        'label'       => 'Tekil Sayfa Üstü Reklam Kodlarınız (728x90)',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea-simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'single_video_alti',
        'label'       => 'Tekil Sayfa Video Altı Reklam Kodlarınız (728x90)',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea-simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      ),
      array(
        'id'          => 'single_dizi_video_ustu',
        'label'       => 'Tekil Dizi Sayfası Video Üstü Reklam Kodlarınız (728x90)',
        'desc'        => '',
        'std'         => '',
        'type'        => 'textarea-simple',
        'section'     => 'reklam',
        'rows'        => '',
        'post_type'   => '',
        'taxonomy'    => '',
        'min_max_step'=> '',
        'class'       => '',
        'condition'   => '',
        'operator'    => 'and'
      )
    )
  );
  
  /* allow settings to be filtered before saving */
  $custom_settings = apply_filters( ot_settings_id() . '_args', $custom_settings );
  
  /* settings are not the same update the DB */
  if ( $saved_settings !== $custom_settings ) {
    update_option( ot_settings_id(), $custom_settings ); 
  }
  
  /* Lets OptionTree know the UI Builder is being overridden */
  global $ot_has_custom_theme_options;
  $ot_has_custom_theme_options = true;
  
}